# supported '--with xxx' values: dietlibc(EXPERIMENTAL)

Name: cpio
Version: 2.6
Release: alt14

Summary: A GNU archiving program
License: GPL
Group: Archiving/Backup
Url: http://www.gnu.org/software/%name/

Source: ftp://ftp.gnu.org/gnu/%name/%name-%version.tar.bz2

Patch1: cpio-2.6-cvs-20050131-umask.patch
Patch2: cpio-2.6-cvs-2004122-configure-mt.patch

Patch11: cpio-2.6-alt-lstat.patch
Patch12: cpio-2.6-alt-i18n.patch
Patch13: cpio-2.6-alt-sparse.patch
Patch14: cpio-2.6-alt-error-details.patch
Patch15: cpio-2.6-alt-warnings.patch
Patch16: cpio-2.6-alt-safer_name_suffix.patch
Patch17: cpio-2.6-alt-chown-chmod.patch
Patch18: cpio-2.6-alt-open-mkdir-mknod.patch
Patch19: cpio-2.6-rh-alt-lfs.patch
Patch20: cpio-2.6-rh-svr4compat.patch
Patch21: cpio-2.6-alt-info.patch
Patch22: cpio-2.6-pld-alt-configure.patch
Patch23: cpio-2.6-deb-find_inode_file.patch

Patch30: cpio-2.6-alt-static-dietlibc.patch
Patch31: cpio-2.6-alt-static.patch

Requires(post): %install_info
Requires(preun): %uninstall_info

# Due to autoreconf which calls autopoint, and autopoint fails without cvs.
BuildPreReq: cvs

%def_without dietlibc

%if_with dietlibc
BuildPreReq: dietlibc
%else
BuildPreReq: glibc-devel-static
%endif

Summary(ru_RU.KOI8-R):     ,   GNU

%package static
Summary: Static version of the GNU cpio
Group: Archiving/Backup
Requires: %name = %version-%release
Summary(ru_RU.KOI8-R):     GNU cpio

%description
GNU cpio copies files into or out of a cpio or tar archive.  Archives
are files which contain a collection of other files plus information
about them, such as their file name, owner, timestamps, and access
permissions.  The archive can be another file on the disk, a magnetic
tape, or a pipe.  GNU cpio supports the following archive formats:  binary,
old ASCII, new ASCII, crc, HPUX binary, HPUX old ASCII, old tar and POSIX.1
tar.  By default, cpio creates binary format archives, so that they are
compatible with older cpio programs.  When it is extracting files from
archives, cpio automatically recognizes which kind of archive it is reading
and can read archives created on machines with a different byte-order.

%description -l ru_RU.KOI8-R
GNU cpio        TAR  CPIO.
     ,    
(  -     ),
     : , 
  ,    ,    ..
      ,   ,  
  (pipe)    . GNU cpio 
  : ,  ASCII,  ASCII, crc,
 HPUX,  ASCII HPUX,  TAR  TAR  POSIX.1.
  GNU cpio     , 
    cpio.   cpio 
  ,  ,  
 ,          .

%description -l uk_UA.KOI8-U
cpio Ц     Ȧ cpio  tar,  Ѥ  ,
 ͦ ۦ   æ  ,   ' , 
,  ,    .. Ȧ   ,
Ҧ  .

%description static
This package contains statically linked version of the GNU cpio program.

%description -l ru_RU.KOI8-R static
   GNU cpio.   ,
 ,   , 
 ,      
     .

%prep
%setup -q

%patch1 -p0
%patch2 -p1

%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1

%if_with dietlibc
%patch30 -p1
%else
%patch31 -p1
%endif

find -type f -name \*.orig -delete -print

%build
# Several patches modify configure.ac and Makefile.am
autoreconf -fisv
%configure --disable-mt --with-rmt=/sbin/rmt
%make_build
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build -k check}}}
bzip2 -9fk ChangeLog

%install
%makeinstall bindir=%buildroot%_bindir mandir=%buildroot%_mandir
%__mkdir_p %buildroot/bin
mv %buildroot%_bindir/%name %buildroot/bin/
mv %buildroot%_bindir/%{name}static %buildroot%_bindir/%name.static

%find_lang %name

%post
%install_info %name.info

%preun
%uninstall_info %name.info

%files -f %name.lang
/bin/%name
%_infodir/%name.info*
%_mandir/man?/%name.*
%doc AUTHORS ChangeLog.bz2 NEWS README THANKS TODO
%exclude %_man1dir/mt.*

%files static
%_bindir/%name.static

%changelog
* Mon May 16 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt14
- Fixed dircategory entry in texinfo documentation.

* Mon May 16 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt13
- Configure with proper rmt(8) location: /sbin/rmt.
- Do not even build rmt.

* Fri May 13 2005 ALT QA Team Robot <qa-robot@altlinux.org> 2.6-alt12.1
- Rebuilt with glibc-devel-static-2.3.5-alt2.

* Wed May 11 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt12
- Fixed race condition while setting permissions
  in copy-in and copy-pass modes:
  + corrected directory creation algorithm to chmod existing
    directory using safe mode before chown, for each directory
    which is going to be reused by cpio.

* Tue May 10 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt11
- Rebuilt with glibc-2.3.5-alt1.

* Fri May 06 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt10
- Fixed two race condition issues while setting permissions
  in copy-in and copy-pass modes:
  + corrected open(2) calls to use O_EXCL;
  + corrected mkdir(2) and mknod(2) calls to use safe permissions.

* Thu May 05 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt9
- Applied find_inode_file fix from Debian's cpio package.

* Tue May 03 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt8
- Fixed several race condition issues while setting permissions
  in copy-in and copy-pass modes (CAN-2005-1111).
- Removed patches:
  mtime: obsolete;
  stdout: invalid;
  errorcode: broken;
- Renamed patched according to our conventions, rediffed
  and renumbered them.
- Deal with compilation warnings generated by compiler.

* Tue Apr 26 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt7
- Fixed directory traversal issue in copy-in and copy-pass
  modes (CAN-2005-1229).

* Tue Feb 01 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt6
- Updated lfs patch.
- Fixed umask issue (CAN-1999-1572).

* Tue Feb 01 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt5
- Fixed lstat support.

* Tue Feb 01 2005 Dmitry V. Levin <ldv@altlinux.org> 2.6-alt4
- Build with fresh automake.
- Fixed i18n patch.
- Reenabled "--extract --sparse".

* Thu Jan 27 2005 Ilya Evseev <evseev@altlinux.ru> 2.6-alt3
- autoreconf is called between patching and calling configure script
- added EXPERIMENTAL unfinished building of static version
  using diet-libc instead of glibc-static for reducing size
- few docfiles additionally placed to packaging

* Sun Jan  9 2005 Ilya Evseev <evseev@altlinux.ru> 2.6-alt2
- specfile: change (un)install_info dependency to modern style

* Tue Jan  7 2005 Ilya Evseev <evseev@altlinux.ru> 2.6-alt1
- version 2.6
- patchset changes:
   + commented obsoleted patches #1 (no more glibc problems)
     and #6 (superceded by patch #3)
   + reapplied patches 4,5,9,10
   + patch #3 is upgraded from old incomplete ALT to actual full MDK
   + added patches 2,7(replacing old RH/ALT patches),21,22 from PLD
   + todo's: patch #8 still unapplied; compile warnings still not fixed
- other specfile changes:
   + added russian summary and description
   + added ukrainian description, taken from PLD
   + completely ignore mt/rmt stuff
   + use find_lang for processing message files

* Fri Apr 11 2003 Dmitry V. Levin <ldv@altlinux.org> 2.5-alt4
- Updated buildrequires.

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 2.5-alt3
- Build static version of the GNU cpio program.
- Added more verbosity to error messages.

* Tue Oct 29 2002 Dmitry V. Levin <ldv@altlinux.org> 2.5-alt2
- Rebuilt in new environment.

* Thu Aug 01 2002 Dmitry V. Levin <ldv@altlinux.org> 2.5-alt1
- 2.5, 5 patches merged upstream.

* Mon Oct 08 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.4.2-ipl18mdk
- Merged patches (redhat, debian).

* Wed Jan 10 2001 Dmitry V. Levin <ldv@fandra.org> 2.4.2-ipl17mdk
- Fixed texinfo documentation.

* Wed Jul 12 2000 Dmitry V. Levin <ldv@fandra.org> 2.4.2-ipl16mdk
- RE adaptions.

* Tue Jul 11 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.4.2-16mdk
- clean a lot the spec (macros, install fix by Stefan van der Eijk
  <s.vandereijk@chello.nl>)
- use spechelper

* Sat Jul 08 2000 Stefan van der Eijk <s.vandereijk@chello.nl> 2.4.2-16mdk
- fixed makeinstall problem
- some hassle getting the manpage in the right dir

* Thu Apr 4 2000 Denis Havlik <denis@mandrakesoft.com> 2.4.2-15mdk
- new Group: Archiving/Backup

* Wed Oct 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Specs files tweaks.
- Merge with rh patchs.
- fix infinite loop unpacking empty files with hard links (r).
- stdout chould contain progress information (r).

* Fri Apr  9 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale

* Sat Dec  5 1998 Jeff Johnson <jbj@redhat.com>
- longlong dev wrong with "-o -H odc" headers (formerly "-oc").

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- patch to compile on glibc 2.1, where strdup is a macro

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- Fiddle bindir/libexecdir to get RH install correct.
- Don't include /sbin/rmt -- use the rmt from dump package.
- Don't include /bin/mt -- use the mt from mt-st package.
- Add prereq's

* Tue Jun 30 1998 Jeff Johnson <jbj@redhat.com>
- fix '-c' to duplicate svr4 behavior (problem #438)
- install support programs & info pages

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri Oct 17 1997 Donnie Barnes <djb@redhat.com>
- added BuildRoot
- removed "(used by RPM)" comment in Summary

* Thu Jun 19 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- no longer statically linked as RPM doesn't use cpio for unpacking packages
